#!/usr/bin/env python

##############################################################################
# This script takes a 336-byte curl generated data file and turns it into a 
# 136-byte decoded .pkm file.
#
# It relies on stuff in ir-gts-bw's code library, found in <ir-gts-bw_dir>/src
#
#    -ben
# bpkelley59 AT gmail DOT com
# http://projectpokemon.org/forums/member.php?27134-bpk59
##############################################################################

from pokehaxlib import *
from sys import *
from pkmlib import encode, decode
from platform import system
from boxtoparty import *
import os, struct, re

def prep_pkm( pkm_file ):
    global pkm
    if (len(pkm_file) == 0) or (pkm_file == 'NONE') :
        print 'Enter the path or drag the pkm file here:'
        path = raw_input().strip()
    else:
        path = pkm_file.strip()
    path = os.path.normpath(path)
    if system() != 'Windows':
        path = path.replace('\\', '')
    if path.startswith('"') or path.startswith("'"):
        path = path[1:]
    if path.endswith('"') or path.endswith("'"):
        path = path[:-1]
    if path.lower().endswith('.pkm'):
        with open(path, 'rb') as f:
            pkm = f.read()
    f.close
    pkm = decode(pkm)
    if len(pkm) != 136:
	print path,"does not equal 136 bytes, trimming ..."
	pkm = pkm[0:136] #-- only take the top 136 bytes
    new_pkm_file_name = pkm_file.replace('.pkm','.136.decoded.pkm')
    print "Writing new pkm file:",new_pkm_file_name
    new_pkm_fh = open ( new_pkm_file_name, 'w' )
    new_pkm_fh.write(pkm)
    new_pkm_fh.close

#-- main
if (len(sys.argv) > 1) and (len(argv[1]) != 0):
    prep_pkm( argv[1] )
else:
    prep_pkm ('NONE')

exit(0)
